/*
 * _gen/svc-OLPC_Buddy_Info.h - Header for GabbleSvcOLPCBuddyInfo
 *
 *  Copyright (C) 2007 Collabora Limited 
 *
 * This file may be distributed under the same terms as the specification
 * from which it is generated.
 */

#ifndef __GABBLE_SVC_OLPC_BUDDY_INFO_H__
#define __GABBLE_SVC_OLPC_BUDDY_INFO_H__

#include <glib-object.h>
#include <dbus/dbus-glib.h>

G_BEGIN_DECLS

/**
 * GabbleSvcOLPCBuddyInfo:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _GabbleSvcOLPCBuddyInfo GabbleSvcOLPCBuddyInfo;

/**
 * GabbleSvcOLPCBuddyInfoClass:
 *
 * The class of GabbleSvcOLPCBuddyInfo.
 */
typedef struct _GabbleSvcOLPCBuddyInfoClass GabbleSvcOLPCBuddyInfoClass;


GType gabble_svc_olpc_buddy_info_get_type (void);

/* TYPE MACROS */
#define GABBLE_TYPE_SVC_OLPC_BUDDY_INFO \
  (gabble_svc_olpc_buddy_info_get_type ())
#define GABBLE_SVC_OLPC_BUDDY_INFO(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), GABBLE_TYPE_SVC_OLPC_BUDDY_INFO, GabbleSvcOLPCBuddyInfo))
#define GABBLE_IS_SVC_OLPC_BUDDY_INFO(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), GABBLE_TYPE_SVC_OLPC_BUDDY_INFO))
#define GABBLE_SVC_OLPC_BUDDY_INFO_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GABBLE_TYPE_SVC_OLPC_BUDDY_INFO, GabbleSvcOLPCBuddyInfoClass))


typedef void (*gabble_svc_olpc_buddy_info_get_activities_impl) (GabbleSvcOLPCBuddyInfo *self,
                                                                guint contact,
                                                                DBusGMethodInvocation *context);
void gabble_svc_olpc_buddy_info_implement_get_activities (GabbleSvcOLPCBuddyInfoClass *klass, gabble_svc_olpc_buddy_info_get_activities_impl impl);


/**
 * gabble_svc_olpc_buddy_info_return_from_get_activities:
 * @dbus_context: The D-Bus method invocation context
 * @activities: FIXME: document args in genginterface
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
gabble_svc_olpc_buddy_info_return_from_get_activities (DBusGMethodInvocation *dbus_context,
                                                       const GPtrArray *activities)
;
static inline void
gabble_svc_olpc_buddy_info_return_from_get_activities (DBusGMethodInvocation *dbus_context,
                                                       const GPtrArray *activities)
{
  dbus_g_method_return (dbus_context, activities);
}
typedef void (*gabble_svc_olpc_buddy_info_get_current_activity_impl) (GabbleSvcOLPCBuddyInfo *self,
                                                                      guint contact,
                                                                      DBusGMethodInvocation *context);
void gabble_svc_olpc_buddy_info_implement_get_current_activity (GabbleSvcOLPCBuddyInfoClass *klass, gabble_svc_olpc_buddy_info_get_current_activity_impl impl);


/**
 * gabble_svc_olpc_buddy_info_return_from_get_current_activity:
 * @dbus_context: The D-Bus method invocation context
 * @activity: FIXME: document args in genginterface
 * @channel: FIXME: document args in genginterface
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
gabble_svc_olpc_buddy_info_return_from_get_current_activity (DBusGMethodInvocation *dbus_context,
                                                             const gchar *activity,
                                                             guint channel)
;
static inline void
gabble_svc_olpc_buddy_info_return_from_get_current_activity (DBusGMethodInvocation *dbus_context,
                                                             const gchar *activity,
                                                             guint channel)
{
  dbus_g_method_return (dbus_context, activity, channel);
}
typedef void (*gabble_svc_olpc_buddy_info_get_properties_impl) (GabbleSvcOLPCBuddyInfo *self,
                                                                guint contact,
                                                                DBusGMethodInvocation *context);
void gabble_svc_olpc_buddy_info_implement_get_properties (GabbleSvcOLPCBuddyInfoClass *klass, gabble_svc_olpc_buddy_info_get_properties_impl impl);


/**
 * gabble_svc_olpc_buddy_info_return_from_get_properties:
 * @dbus_context: The D-Bus method invocation context
 * @properties: FIXME: document args in genginterface
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
gabble_svc_olpc_buddy_info_return_from_get_properties (DBusGMethodInvocation *dbus_context,
                                                       GHashTable *properties)
;
static inline void
gabble_svc_olpc_buddy_info_return_from_get_properties (DBusGMethodInvocation *dbus_context,
                                                       GHashTable *properties)
{
  dbus_g_method_return (dbus_context, properties);
}
typedef void (*gabble_svc_olpc_buddy_info_set_activities_impl) (GabbleSvcOLPCBuddyInfo *self,
                                                                const GPtrArray *activities,
                                                                DBusGMethodInvocation *context);
void gabble_svc_olpc_buddy_info_implement_set_activities (GabbleSvcOLPCBuddyInfoClass *klass, gabble_svc_olpc_buddy_info_set_activities_impl impl);


/**
 * gabble_svc_olpc_buddy_info_return_from_set_activities:
 * @dbus_context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
gabble_svc_olpc_buddy_info_return_from_set_activities (DBusGMethodInvocation *dbus_context)
;
static inline void
gabble_svc_olpc_buddy_info_return_from_set_activities (DBusGMethodInvocation *dbus_context)
{
  dbus_g_method_return (dbus_context);
}
typedef void (*gabble_svc_olpc_buddy_info_set_current_activity_impl) (GabbleSvcOLPCBuddyInfo *self,
                                                                      const gchar *activity,
                                                                      guint channel,
                                                                      DBusGMethodInvocation *context);
void gabble_svc_olpc_buddy_info_implement_set_current_activity (GabbleSvcOLPCBuddyInfoClass *klass, gabble_svc_olpc_buddy_info_set_current_activity_impl impl);


/**
 * gabble_svc_olpc_buddy_info_return_from_set_current_activity:
 * @dbus_context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
gabble_svc_olpc_buddy_info_return_from_set_current_activity (DBusGMethodInvocation *dbus_context)
;
static inline void
gabble_svc_olpc_buddy_info_return_from_set_current_activity (DBusGMethodInvocation *dbus_context)
{
  dbus_g_method_return (dbus_context);
}
typedef void (*gabble_svc_olpc_buddy_info_set_properties_impl) (GabbleSvcOLPCBuddyInfo *self,
                                                                GHashTable *properties,
                                                                DBusGMethodInvocation *context);
void gabble_svc_olpc_buddy_info_implement_set_properties (GabbleSvcOLPCBuddyInfoClass *klass, gabble_svc_olpc_buddy_info_set_properties_impl impl);


/**
 * gabble_svc_olpc_buddy_info_return_from_set_properties:
 * @dbus_context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
gabble_svc_olpc_buddy_info_return_from_set_properties (DBusGMethodInvocation *dbus_context)
;
static inline void
gabble_svc_olpc_buddy_info_return_from_set_properties (DBusGMethodInvocation *dbus_context)
{
  dbus_g_method_return (dbus_context);
}
void gabble_svc_olpc_buddy_info_emit_activities_changed (gpointer instance,
    const guint  contact,
    const GPtrArray * activities);

void gabble_svc_olpc_buddy_info_emit_current_activity_changed (gpointer instance,
    const guint  contact,
    const gchar * activity,
    const guint  channel);

void gabble_svc_olpc_buddy_info_emit_properties_changed (gpointer instance,
    const guint  contact,
    const GHashTable * properties);



G_END_DECLS

#endif /* #ifndef __GABBLE_SVC_OLPC_BUDDY_INFO_H__*/
